%define _buildid .11

%global py26nvr python26-jmespath-%{version}-%{release}
%global py26builddir %{_builddir}/%{py26nvr}
%global py26doc ../%{py26nvr}

%global py27nvr python27-jmespath-%{version}-%{release}
%global py27builddir %{_builddir}/%{py27nvr}
%global py27doc ../%{py27nvr}

%bcond_without tests # with

%global upstream_name jmespath

Name: python-jmespath
Version: 0.9.0
Release: 1%{?_buildid}%{?dist}
Summary: JMESPath allows you to declaratively specify how to extract elements from a JSON document.
Group: Development/Languages
License: MIT
URL: https://github.com/jmespath/jmespath.py
Source0: %{url}/archive/%{version}.tar.gz
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: python26
BuildRequires: python27

%description
JMESPath allows you to declaratively specify how to extract elements from a
JSON document.

For example, given this document: {"foo": {"bar": "baz"}} The jmespath
expression foo.bar will return "baz".

JMESPath also supports referencing elements in a list. Given the data:
{"foo": {"bar": ["one", "two"]}} The expression: foo.bar[*].name will return
["one", "two"]. Negative indexing is also supported (-1 refers to the last
element in the list). Given the data above, the expression foo.bar[-1].name
will return ["two"]. The * can also be used for hash types: {"foo": {"bar":
{"name": "one"}, "baz": {"name": "two"}}} The expression: foo.*.name will
return ["one", "two"].

%package -n python26-jmespath
Summary: JMESPath allows you to declaratively specify how to extract elements from a JSON document.
BuildRequires: python26-devel
# Needed for checks, versions taken from requirements26.txt
BuildRequires: python26-ordereddict >= 1.1
BuildRequires: python26-simplejson >= 3.6.5
BuildRequires: python26-unittest2 >= 0.5.1
BuildRequires: python26-ply >= 3.4
BuildRequires: python26-nose
Requires: python26(alternatives)
Requires: alternatives(addslave)
Requires: alternatives(removeslave)
Requires: alternatives(force)
Requires(preun): python26(alternatives)
Requires(preun): alternatives(removeslave)
Requires: python26-ply >= 3.4
Requires: python26-argparse
Provides: python-jmespath = %{version}-%{release}
Obsoletes: python-jmespath <= 0.6.1-1.2.amzn1

%description -n python26-jmespath
JMESPath allows you to declaratively specify how to extract elements from a
JSON document.

For example, given this document: {"foo": {"bar": "baz"}} The jmespath
expression foo.bar will return "baz".

JMESPath also supports referencing elements in a list. Given the data:
{"foo": {"bar": ["one", "two"]}} The expression: foo.bar[*].name will return
["one", "two"]. Negative indexing is also supported (-1 refers to the last
element in the list). Given the data above, the expression foo.bar[-1].name
will return ["two"]. The * can also be used for hash types: {"foo": {"bar":
{"name": "one"}, "baz": {"name": "two"}}} The expression: foo.*.name will
return ["one", "two"].

This package is meant to be used with Python 2.6.

%package -n python27-jmespath
Summary: JMESPath allows you to declaratively specify how to extract elements from a JSON document.
BuildRequires: python27-devel
# Needed for checks, versions taken from requirements26.txt
BuildRequires: python27-simplejson >= 3.6.5
BuildRequires: python27-unittest2 >= 0.5.1
BuildRequires: python27-ply >= 3.4
BuildRequires: python27-nose
Requires: python27(alternatives)
Requires: alternatives(addslave)
Requires: alternatives(removeslave)
Requires: alternatives(force)
Requires(preun): python27(alternatives)
Requires(preun): alternatives(removeslave)
Requires: python27-ply >= 3.4
Conflicts: python-jmespath <= 0.5.0-1.1.amzn1

%description -n python27-jmespath
JMESPath allows you to declaratively specify how to extract elements from a
JSON document.

For example, given this document: {"foo": {"bar": "baz"}} The jmespath
expression foo.bar will return "baz".

JMESPath also supports referencing elements in a list. Given the data:
{"foo": {"bar": ["one", "two"]}} The expression: foo.bar[*].name will return
["one", "two"]. Negative indexing is also supported (-1 refers to the last
element in the list). Given the data above, the expression foo.bar[-1].name
will return ["two"]. The * can also be used for hash types: {"foo": {"bar":
{"name": "one"}, "baz": {"name": "two"}}} The expression: foo.*.name will
return ["one", "two"].

This package is meant to be used with Python 2.7.

%prep
%setup -q -n jmespath.py-%{version}

%build
rm -rf %{py26builddir}
mkdir -p %{py26builddir}
cp -a * %{py26builddir}
pushd %{py26builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python26} setup.py build 
popd

rm -rf %{py27builddir}
mkdir -p %{py27builddir}
cp -a * %{py27builddir}
pushd %{py27builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python27} setup.py build 
popd

%install
rm -rf %{buildroot}

pushd %{py26builddir}
%{__python26} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd
mv %{buildroot}%{_bindir}/jp.py{,-2.6}
ln -s jp.py-2.6 %{buildroot}%{_bindir}/jp-2.6

pushd %{py27builddir}
%{__python27} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd
mv %{buildroot}%{_bindir}/jp.py{,-2.7}
ln -s jp.py-2.7 %{buildroot}%{_bindir}/jp-2.7

%check
%if %{with tests}
pushd %{py26builddir}
%{_bindir}/nosetests-2.6
popd
pushd %{py27builddir}
%{_bindir}/nosetests-2.7
popd
%endif

%clean
rm -rf %{buildroot}
rm -rf %{py26builddir}
rm -rf %{py27builddir}

%triggerin -n python26-jmespath -- python26
# Refresh alternatives when updating python26-jmespath or python26.
%{_sbindir}/update-alternatives \
  --force \
  --update python %{_bindir}/python2.6 \
  --addslave %{_bindir}/jp jp %{_bindir}/jp.py-2.6 \
  --addslave %{_bindir}/jp.py jp.py %{_bindir}/jp.py-2.6 \
  || :

%preun -n python26-jmespath
if [ $1 -eq 0 ]; then
  %{_sbindir}/update-alternatives \
    --update python %{_bindir}/python2.6 \
    --removeslave jp \
    --removeslave jp.py \
 || :
fi

%triggerin -n python27-jmespath -- python27
# Refresh alternatives when updating python27-jmespath or python27.
%{_sbindir}/update-alternatives \
  --force \
  --update python %{_bindir}/python2.7 \
  --addslave %{_bindir}/jp jp %{_bindir}/jp.py-2.7 \
  --addslave %{_bindir}/jp.py jp.py %{_bindir}/jp.py-2.7 \
  || :

%preun -n python27-jmespath
if [ $1 -eq 0 ]; then
  %{_sbindir}/update-alternatives \
    --update python %{_bindir}/python2.7 \
    --removeslave jp \
    --removeslave jp.py \
 || :
fi

%files -n python26-jmespath
%doc LICENSE.txt README.rst
%{python26_sitelib}/*
%{_bindir}/jp.py-2.6
%{_bindir}/jp-2.6
%ghost %{_bindir}/jp
%ghost %{_bindir}/jp.py

%files -n python27-jmespath
%doc LICENSE.txt README.rst
%{python27_sitelib}/*
%{_bindir}/jp.py-2.7
%{_bindir}/jp-2.7
%ghost %{_bindir}/jp
%ghost %{_bindir}/jp.py

%changelog
* Sat May 21 2016 Ian Weller <iweller@amazon.com>
- Update to 0.9.0

* Tue Jun 23 2015 hpetty <hpetty@amazon.com>
- Add a versioned symlink for the jp binary

* Tue May 12 2015 hpetty <hpetty@amazon.com>
- Update to jmespath 0.7.1

* Wed Apr 22 2015 Jason Green <jasg@amazon.com>
- Update to jmespath 0.6.2

* Thu Mar 12 2015 Tom Kirchner <tjk@amazon.com>
- Update to jmespath 0.6.1

* Fri Feb 27 2015 Ben Cressey <bcressey@amazon.com>
- add alternatives for jp

* Wed Feb 4 2015 Ben Cressey <bcressey@amazon.com>
- build for multiple pythons
